{ Backspoofer v0.1b - Simple backspoofing utility for asterisk.   }
{ Written by vox - 6/27/2005                                      }

{$MODE FPC}
{$Q-,$R-,$S-}

program bspoofer;

uses
  crt, sysutils;

{*** Do NOT remove the single quotation marks when editing the constants below! ***}
const
  cfdir = '/var/spool/asterisk/outgoing/'; (* asterisk .call file directory.          *) 

  schan = 'IAX2/UserID@YourIAXProvider/1'; (* asterisk channel to use for spoofing.   *) 
                                           (* Replace with your IAX2 provider's info! *)
var
  cwait      : string;              
  multispoof : boolean;

(* Processes command line arguments. *)
procedure procargs;  
var
  i,j   : integer;
  s,tmp : string;
begin
  tmp   := '';
  for i := 1 to paramcount do
    begin
      s := upcase(paramstr(i));
      if (length(s) >= 2) and ((s[1] = '-') or (s[1] = '/')) then
        case s[2] of
          'M' : if length(s) = 2 then multispoof := true;
          'W' : begin
                  if (s[3] = ':') and (length(s) >= 4) then
                    begin       
                      tmp := copy(s,4,length(s));
                      if length(tmp) >= 1 then
                        begin
                          cwait := '';
                          for j := 1 to length(tmp) do
                            if tmp[j] in ['0'..'9'] then cwait := cwait+tmp[j]
                            else
                              begin
                                cwait := '7';
                                break;
                              end;
                        end;
                    end;
                end;
        end;
    end;
end;

(* Validates the backspoof data passed to it. *)
procedure valnum(var s : string; var c : integer);
var
  i : integer;
begin
  (* Strip '-' char and spaces if they exist. *)
  for i := 1 to length(s) do 
    if (s[i] = '-') or (s[i] = #32) then delete(s,i,1);
  if length(s) = 10 then
    for i := 1 to length(s) do
      begin
        if not (s[i] in ['0'..'9']) then
          begin
            c := -1; (* Number is not a valid phone number. *)
            exit;
          end;
      end
  else
    begin
      c := -2; (* Length is < 10 chars. *)
      exit;
    end;
  c := length(s); (* All is well. *)
end;


(* Create a .call file and allow asterisk to backspoof the call. *)
procedure spoof(CID,FWD : string);
var
  f  : text;
  fn : string[30];
begin
  randomize;
  repeat
    fn := 'bspoof'+inttostr(random(9999)+1)+inttostr(random(9999)+1)+'.call';
  until not fileexists(cfdir+fn);
  assign(f,cfdir+fn);
  {$I-}
  rewrite(f);
  {$I+}
  if ioresult = 0 then 
    begin
      writeln(f,'Channel: ',schan+FWD);
      writeln(f,'Callerid: ',CID);
      writeln(f,'Application: Dial');
      writeln(f,'MaxRetries: 0');
      writeln(f,'WaitTime: ',cwait);
      close(f);
      write('* Call file created! Backspoof should take effect shortly. Please wait...');
      sleep(strtoint(cwait+'000')+3000);
      writeln;
      if fileexists(cfdir+fn) then
        begin 
          write('* The backspoof was unsuccessful. Make sure asterisk is running.');
          writeln;
          halt(2);
        end
      else write('* The backspoof appears to have been successful!');
    end
  else 
    begin
      writeln('* Error creating .call file. Be sure the .call file directory is set correctly.');
      halt(1);
    end;
end;

(* Prompts for the telephone number(s) to backspoof. *)
procedure getnums;
var
  valc      : integer;
  key       : char;
  fnum,snum : string[12];
begin
  repeat
    write('Enter telephone number to backspoof: ');
    readln(snum);
    valnum(snum,valc);
  until valc > 0;
  repeat
    write('Enter telephone number to spoof to:  ');
    readln(fnum);
    valnum(fnum,valc);
  until valc > 0;
  writeln;
  spoof(snum,fnum);
  if multispoof then
    begin
      writeln;
      writeln;
      write('Do you want to backspoof another number? [Y/N]');
      repeat
        key := upcase(readkey);
      until (key ='N') or (key = 'Y');
      if key = 'Y' then
        begin
          writeln;
          writeln;
          getnums;
        end;
    end;
end;


(* Main *)
begin 
  cwait := '7';
  multispoof := false;
  if paramcount > 0 then procargs;
  clrscr;
  writeln('Backspoofer v0.1b');
  writeln;
  getnums;
  writeln;
end.
